#ifndef GEOMETRY_HPP
#define GEOMETRY_HPP

#include "Common.hpp"
#include "Coord.hpp"

class Polygon
{
public:
    std::vector<Coord> m_vertices;
};

class Segment
{
public:
    Segment() : start(), end() {}
    Segment(const Coord& startIn, const Coord& endIn) :
        start(startIn), end(endIn) {}

public:
    Coord start;
    Coord end;
};

enum class Dir : uint32_t
{
    CCW,
    CW
};

Dir getPolygonDir(const Polygon& polygon);
bool isPolygonConvex(const Polygon& polygon);

// Project a onto b
Coord project(const Coord& a, const Coord& b);

// Reflect a about pq
Coord reflect(const Coord& p, const Coord& q, const Coord& a);

bool intersectLines(const Coord& orig1,
                    const Coord& dir1,
                    const Coord& orig2,
                    const Coord& dir2,
                    mpq_class* pParam1,
                    mpq_class* pParam2);

#endif
