#ifndef RANDOM_HPP
#define RANDOM_HPP

#include "Common.hpp"

class Random
{
public:
    Random() :
        m_state(1)
    {
    }

    Random(uint64_t seed) :
        m_state(seed)
    {
    }

    uint64_t get()
    {
        m_state ^= m_state >> 12;
        m_state ^= m_state << 25;
        m_state ^= m_state >> 27;
        return m_state * UINT64_C(2685821657736338717);
    }

private:
    uint64_t m_state;
};

#endif
